#ifndef DB_H
#define DB_H

#include <sqlite3.h>

#define IOC_DB "IOC_DB"

#define DB_PATH "data.db"

#define QUERY_INSERT_DATA                                                      \
  "INSERT INTO data (device_id, sensor_type, data) VALUES (?, ?, ?);"

#define QUERY_CREATE_TABLE                                                           \
  "CREATE TABLE IF NOT EXISTS data (id INTEGER PRIMARY KEY AUTOINCREMENT, created "  \
  "TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, device_id TEXT NOT NULL, "          \
  "sensor_type TEXT NOT NULL, data INT NOT NULL);"

void init_db(sqlite3 **db);
void clean_db(sqlite3 *db);
void insert_data(char *device_id, char *sensor_type, int data);

#endif /* DB_H */
